Package net.sf.saxon.expr.sort

## Class GroupMatchingIterator

- java.lang.Object
- - net.sf.saxon.expr.sort.GroupMatchingIterator

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `LastPositionFinder`, `GroupIterator`, `SequenceIterator`, `LookaheadIterator`
  Direct Known Subclasses:
    `GroupEndingIterator`, `GroupStartingIterator`

      public abstract class GroupMatchingIterator
      extends java.lang.Object
      implements LookaheadIterator, LastPositionFinder, GroupIterator

  A GroupMatchingIterator contains code shared between GroupStartingIterator and GroupEndingIterator

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected XPathContext` | `baseContext` |
    `protected Item` | `current` |
    `protected java.util.List<Item>` | `currentMembers` |
    `protected Item` | `next` |
    `protected Pattern` | `pattern` |
    `protected FocusIterator` | `population` |
    `protected int` | `position` |
    `protected XPathContext` | `runningContext` |
    `protected Expression` | `select` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `GroupMatchingIterator()` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected abstract void` | `advance()` |
    `void` | `close()` | Close the iterator.
    `AtomicSequence` | `getCurrentGroupingKey()` | Get the grouping key of the current group
    `java.util.EnumSet<SequenceIterator.Property>` | `getProperties()` | Get properties of this iterator.
    `ManualGroupIterator` | `getSnapShot​(XPathContext context)` | Get a sequence which is a snapshot of this sequence at the current position
    `boolean` | `hasNext()` | Determine whether there are more items to come.
    `SequenceIterator` | `iterateCurrentGroup()` | Get an iterator over the members of the current group, in population order.
    `Item` | `next()` | Get the next item in the sequence.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.expr.LastPositionFinder

      `getLength`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `forEachOrFail, materialize`

- - ### Field Detail

    - #### select

          protected Expression select

    - #### population

          protected FocusIterator population

    - #### pattern

          protected Pattern pattern

    - #### baseContext

          protected XPathContext baseContext

    - #### runningContext

          protected XPathContext runningContext

    - #### currentMembers

          protected java.util.List<Item> currentMembers

    - #### next

          protected Item next

    - #### current

          protected Item current

    - #### position

          protected int position

  - ### Constructor Detail

    - #### GroupMatchingIterator

          public GroupMatchingIterator()

  - ### Method Detail

    - #### advance

          protected abstract void advance()
                                   throws XPathException

      Throws:
        `XPathException`

    - #### getCurrentGroupingKey

          public AtomicSequence getCurrentGroupingKey()

      Description copied from interface: `GroupIterator`
      Get the grouping key of the current group
      Specified by:
        `getCurrentGroupingKey` in interface `GroupIterator`
      Returns:
        the current grouping key in the case of group-by or group-adjacent, or null in the case of group-starting-with and group-ending-with

    - #### iterateCurrentGroup

          public SequenceIterator iterateCurrentGroup()

      Description copied from interface: `GroupIterator`
      Get an iterator over the members of the current group, in population order. This must always be a clean iterator, that is, an iterator that starts at the first item of the group.
      Specified by:
        `iterateCurrentGroup` in interface `GroupIterator`
      Returns:
        an iterator over all the members of the current group, in population order.

    - #### hasNext

          public boolean hasNext()

      Description copied from interface: `LookaheadIterator`
      Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.

      This method must not be called unless the result of getProperties() on the iterator includes the property `SequenceIterator.Property.LOOKAHEAD`

      Specified by:
        `hasNext` in interface `LookaheadIterator`
      Returns:
        true if there are more items in the sequence

    - #### next

          public Item next()
                    throws XPathException

      Description copied from interface: `SequenceIterator`
      Get the next item in the sequence. This method changes the state of the iterator.
      Specified by:
        `next` in interface `SequenceIterator`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
      Throws:
        `XPathException` - if an error occurs retrieving the next item

    - #### close

          public void close()

      Description copied from interface: `SequenceIterator`
      Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

      For example, the iterator returned by the unparsed-text-lines() function has a close() method that causes the underlying input stream to be closed, whether or not the file has been read to completion.

      Closing an iterator is important when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.io.Closeable`
      Specified by:
        `close` in interface `SequenceIterator`

    - #### getProperties

          public java.util.EnumSet<SequenceIterator.Property> getProperties()

      Description copied from interface: `SequenceIterator`
      Get properties of this iterator.
      Specified by:
        `getProperties` in interface `SequenceIterator`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.Property.GROUNDED`, `SequenceIterator.Property.LAST_POSITION_FINDER`, and `SequenceIterator.Property.LOOKAHEAD`. It is always acceptable to return the default value `EnumSet.noneOf(Property.class)`, indicating that there are no known special properties. It is acceptable (though unusual) for the properties of the iterator to change depending on its state.

    - #### getSnapShot

          public ManualGroupIterator getSnapShot​(XPathContext context)

      Description copied from interface: `GroupIterator`
      Get a sequence which is a snapshot of this sequence at the current position
      Specified by:
        `getSnapShot` in interface `GroupIterator`